/* VisNow
   Copyright (C) 2006-2019 University of Warsaw, ICM
   Copyright (C) 2020 onward visnow.org
   All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.writers.CSVWriter;

import java.awt.Dimension;
import java.io.File;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.gui.swingwrappers.TextField;
import static org.visnow.vn.lib.basic.writers.CSVWriter.CSVWriterShared.*;
import org.visnow.vn.system.main.VisNow;
import org.visnow.vn.system.swing.filechooser.VNFileChooser;

/**
 * GUI for HDF5 writer.
 *
 * @author Piotr Wendykier (p.wendykier@uksw.edu.pl)
 */
public class GUI extends javax.swing.JPanel
{

    private static final long serialVersionUID = -1883452479819311533L;

    private String lastPath = null;
    private Parameters parameters;

    private final FileNameExtensionFilter csvFilter = new FileNameExtensionFilter("CSV files (*.csv)", "csv", "CSV");
    private final FileNameExtensionFilter tsvFilter = new FileNameExtensionFilter("TSV files (*.tsv)", "tsv", "TSV");
    private final int listRowHeight = 18;

    public GUI()
    {
        initComponents();
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p)
    {
        tfFileName.setText(p.get(FILENAME));
        clearComponentSelector();
        chooseComponents(p.get(META_COMPONENT_NAMES));
        if (p.get(FIELD_DELIMITER).equals("\t")) {
            delimiterTF.setText("\\t");
        } else {
            delimiterTF.setText(p.get(FIELD_DELIMITER));
        }
    }

    private void clearComponentSelector()
    {
        componentSelectorList.removeAll();
        componentSelectorList.setModel(new DefaultListModel<>());
        componentSelectorList.setBackground(new java.awt.Color(238, 238, 238));
        componentSelectorList.setEnabled(false);
        componentSelectorScrollPane.setEnabled(false);
    }

    private void chooseComponents(String[] componentNames)
    {
        if (componentNames == null)
            return;
        DefaultListModel<String> componentsListModel = new DefaultListModel<>();
        for (int i = 0; i < componentNames.length; ++i)
            componentsListModel.addElement(componentNames[i]);

        if (componentsListModel.isEmpty()) {
            clearComponentSelector();
            return;
        }

        componentSelectorScrollPane.setEnabled(true);
        componentSelectorList.setEnabled(true);
        componentSelectorList.setBackground(new java.awt.Color(255, 255, 255));
        componentSelectorList.setModel(componentsListModel);
        Dimension listSize = new Dimension(componentSelectorList.getWidth(), componentsListModel.getSize() * listRowHeight);
        componentSelectorList.setPreferredSize(listSize);
        componentSelectorList.setSize(listSize);
        componentSelectorScrollPane.revalidate();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        formatGroup = new javax.swing.ButtonGroup();
        fileChooser = new javax.swing.JFileChooser();
        selectButton = new javax.swing.JButton();
        tfFileName = new javax.swing.JTextField();
        writeButton = new javax.swing.JButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0));
        visNowComponentsLabel = new javax.swing.JLabel();
        componentSelectorScrollPane = new javax.swing.JScrollPane();
        componentSelectorList = new javax.swing.JList();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        customSizePanel1 = new org.visnow.vn.system.swing.CustomSizePanel();
        delimiterTF = new org.visnow.vn.gui.swingwrappers.TextField();

        setMinimumSize(new java.awt.Dimension(180, 122));
        setOpaque(false);
        setPreferredSize(new java.awt.Dimension(200, 200));
        setLayout(new java.awt.GridBagLayout());

        selectButton.setText("select file");
        selectButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                selectButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(selectButton, gridBagConstraints);

        tfFileName.setMinimumSize(new java.awt.Dimension(4, 22));
        tfFileName.setPreferredSize(new java.awt.Dimension(78, 22));
        tfFileName.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                tfFileNameActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(tfFileName, gridBagConstraints);

        writeButton.setText("write file");
        writeButton.setEnabled(false);
        writeButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                writeButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(writeButton, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);

        visNowComponentsLabel.setText("Component:\n");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 0);
        add(visNowComponentsLabel, gridBagConstraints);

        componentSelectorScrollPane.setEnabled(false);
        componentSelectorScrollPane.setMinimumSize(new java.awt.Dimension(150, 200));
        componentSelectorScrollPane.setPreferredSize(new java.awt.Dimension(220, 300));

        componentSelectorList.setBackground(new java.awt.Color(238, 238, 238));
        componentSelectorList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        componentSelectorList.setToolTipText("Choose a component ...");
        componentSelectorList.setEnabled(false);
        componentSelectorList.setMaximumSize(new java.awt.Dimension(400, 1000));
        componentSelectorList.setMinimumSize(new java.awt.Dimension(150, 200));
        componentSelectorList.setPreferredSize(new java.awt.Dimension(150, 500));
        componentSelectorList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
        {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt)
            {
                componentSelectorListValueChanged(evt);
            }
        });
        componentSelectorScrollPane.setViewportView(componentSelectorList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(componentSelectorScrollPane, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel2.setText("Field separator:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        jPanel2.add(jLabel2, gridBagConstraints);

        customSizePanel1.setCustomWidth(40);
        customSizePanel1.setOverrideMinSize(true);
        customSizePanel1.setLayout(new java.awt.GridBagLayout());

        delimiterTF.setHorizontalAlignment(javax.swing.JTextField.TRAILING);
        delimiterTF.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                delimiterTFUserChangeAction(evt);
            }
        });
        delimiterTF.addFocusListener(new java.awt.event.FocusAdapter()
        {
            public void focusGained(java.awt.event.FocusEvent evt)
            {
                delimiterTFselectAllOnFocus(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        customSizePanel1.add(delimiterTF, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 0;
        jPanel2.add(customSizePanel1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(jPanel2, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void tfFileNameActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_tfFileNameActionPerformed
    {//GEN-HEADEREND:event_tfFileNameActionPerformed
        parameters.setParameterActive(false);
        parameters.set(FILENAME, tfFileName.getText());
        parameters.setParameterActive(true);
    }//GEN-LAST:event_tfFileNameActionPerformed

    private void writeButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_writeButtonActionPerformed
    {//GEN-HEADEREND:event_writeButtonActionPerformed
        String path = parameters.get(FILENAME);
        if (path != null) {
            parameters.set(WRITE, !parameters.get(WRITE));
        }
    }//GEN-LAST:event_writeButtonActionPerformed

    private void selectButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_selectButtonActionPerformed
    {//GEN-HEADEREND:event_selectButtonActionPerformed
        if (lastPath == null) {
            fileChooser.setCurrentDirectory(new File(VisNow.get().getMainConfig().getUsableDataPath(CSVWriter.class)));
        } else {
            fileChooser.setCurrentDirectory(new File(lastPath));
        }
        fileChooser.addChoosableFileFilter(csvFilter);
        fileChooser.addChoosableFileFilter(tsvFilter);
        fileChooser.setLocation(0, 0);
        fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        fileChooser.setFileFilter(csvFilter);
        fileChooser.setMultiSelectionEnabled(false);

        String path;
        int returnVal = fileChooser.showDialog(this, "Select");
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            path = VNFileChooser.filenameWithExtenstionAddedIfNecessary(fileChooser.getSelectedFile(),
                                                                        fileChooser.getFileFilter().equals(csvFilter) ? new FileNameExtensionFilter("", "csv", "CSV") : new FileNameExtensionFilter("", "tsv", "TSV"));
            tfFileName.setText(path);
            lastPath = path.substring(0, path.lastIndexOf(File.separator));
            VisNow
                .get().getMainConfig().setLastDataPath(lastPath, CSVWriter.class
                );
            parameters.setParameterActive(false);
            parameters.set(FILENAME, path);
            parameters.setParameterActive(true);
        }
    }//GEN-LAST:event_selectButtonActionPerformed

    private void componentSelectorListValueChanged(javax.swing.event.ListSelectionEvent evt)//GEN-FIRST:event_componentSelectorListValueChanged
    {//GEN-HEADEREND:event_componentSelectorListValueChanged
        if (componentSelectorList.getSelectedIndices().length == 0) {
            componentSelectorList.setToolTipText("Choose a component ...");
            writeButton.setEnabled(false);
        }
        if (!evt.getValueIsAdjusting() && (componentSelectorList.getSelectedIndices().length != 0)) {
            int index = componentSelectorList.getSelectedIndex();

            parameters.setParameterActive(false);
            parameters.set(SELECTED_COMPONENT_INDEX, index);
            parameters.setParameterActive(true);
            writeButton.setEnabled(true);
        }
    }//GEN-LAST:event_componentSelectorListValueChanged

    private void delimiterTFUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_delimiterTFUserChangeAction
    {//GEN-HEADEREND:event_delimiterTFUserChangeAction
        if (delimiterTF.getText().isEmpty()) {
            delimiterTF.setText(",");
        } else {
            parameters.setParameterActive(false);
            parameters.set(FIELD_DELIMITER, delimiterTF.getText());
            parameters.setParameterActive(true);
        }
    }//GEN-LAST:event_delimiterTFUserChangeAction

    private void delimiterTFselectAllOnFocus(java.awt.event.FocusEvent evt)//GEN-FIRST:event_delimiterTFselectAllOnFocus
    {//GEN-HEADEREND:event_delimiterTFselectAllOnFocus
        ((TextField) evt.getSource()).selectAll();
    }//GEN-LAST:event_delimiterTFselectAllOnFocus

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JList componentSelectorList;
    private javax.swing.JScrollPane componentSelectorScrollPane;
    private org.visnow.vn.system.swing.CustomSizePanel customSizePanel1;
    private org.visnow.vn.gui.swingwrappers.TextField delimiterTF;
    private javax.swing.JFileChooser fileChooser;
    private javax.swing.Box.Filler filler1;
    private javax.swing.ButtonGroup formatGroup;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton selectButton;
    private javax.swing.JTextField tfFileName;
    private javax.swing.JLabel visNowComponentsLabel;
    private javax.swing.JButton writeButton;
    // End of variables declaration//GEN-END:variables
}
